/*
   prog5-5.cpp

   Demonstrerar, tillsammans med prog5-6.cpp, skillnaden mellan polymorfa
   och icke polymorfa klasser. En lista med anstllda sparas i vektorn list,
   och funktionen report anvnds fr att lta varje anstlld i listan avge
   rapport (via medlemsfunktionen report). 
   Eftersom medlemsfunktionen report hela tiden anropas via en pekare till
   employee, kommer alltid employee::report (och inte manager::report) att
   anropas, vilket innebr att chefens extra information (en lista ver
   medlemmar i gruppen) aldrig att skrivas ut. 
   Ytterligare ett problem r att nr vi sist i programmet deallokerar 
   alla element i vektorn list grs ven detta via pekare till employee, 
   s manager:s destruktor kommer aldrig att anropas.
*/

#include <iostream.h>
#include <string.h>

// klassen employee
class employee
{
  private:
    
    char* name;
    int   salary;

  public:

    // konstruktor
    employee(const char*, int = 13000);

    // hmta namn och ln
    const char* getname() { return name; }
    const int getsalary() { return salary; }

    // rapportera
    void report();

    // destruktor
    ~employee() { };
};

// konstruktor fr employee
employee::employee(const char* n, int s)
: salary(s)
{
  name = new char[strlen(n)+1];
  strcpy(name,n);
}

// anstllds rapport
void employee::report()
{
  cout << name << ' ';
  cout << salary << ' ';
}

// klassen manager
class manager : public employee
{
  private:

    employee** group;
    int        groupsize;

  public:

    // konstruktor
    manager(const char*, int = 20000);

    // rapportera
    void report();

    // lgg till en anstlld i gruppen
    void hire(employee*);

    // destruktor
    ~manager();
};

// konstruktor fr manager
manager::manager(const char* n, int s)
: employee(n,s)
{
  // skapa en grupp utan medlemmar
  groupsize = 0;
  group = new employee*[groupsize+1];
  group[groupsize] = 0;
}

// chefs rapport
void manager::report()
{
  employee::report();  
  
  // skriv ut medlemmar i arbetsgruppen
  cout << "( ";
  for(employee** e = group; *e != 0; e++)
  {
    cout << (*e)->getname() << ' ';
  }
  cout << ") ";
}

// lgg till en anstlld i gruppen
void manager::hire(employee* newemp)
{
  // ka gruppstorlek med ett
  groupsize++;
  
  // skapa en ny grupp, med plats fr ytterligare en medlem
  employee** newgroup = new employee*[groupsize+1];

  // kopiera de gamla gruppmedlemmarna
  for(int i = 0; i < groupsize - 1; i++)
  {
    newgroup[i] = group[i];
  }
  
  // lgg till ny medarbetare i den nya gruppen
  newgroup[groupsize-1] = newemp;

  // avsluta listan med null
  newgroup[groupsize] = 0;

  // ta bort gammal grupp
  delete[] group;

  // anvnd ny grupp istllet 
  group = newgroup;
}

// destruktor fr manager
manager::~manager()
{
  // manager ansvarar inte fr destruktion av employee-objekten
  // i gruppen, bara fr listan med pekare
  delete[] group;
}

// skriv ut en rapport fr alla anstllda
void report(employee** emp, int n)
{
  for(int i=0; i < n; i++)
  {
    emp[i]->report();
    cout << '\n';
  }
}

main()
{
  const int employees = 5;
  employee* list[employees];

  // lgg till anstllda
  list[0] = new employee("Siv");
  list[1] = new employee("Sten",15000);
  list[2] = new employee("Sren");
  list[3] = new employee("Susan",14000);

  // lgg till chef fr de vriga
  manager* boss = new manager("Stan");
  boss->hire(list[0]);
  boss->hire(list[1]);
  boss->hire(list[2]);
  boss->hire(list[3]);
  list[4] = boss;

  // skriv ut rapport fr alla anstllda
  cout << "Aktuell anstllningsstatus:\n";
  report(list,employees);

  // glm inte bort att deallokera allokerat minne!
  for(int i=0;i<employees;i++)
  {
    delete list[i];
  }

  return 0;
}


